while(isObject(trustManagerGUI))
   trustManagerGUI.delete();
while(isObject(trustDemoteFull))
   trustDemoteFull.delete();
while(isObject(trustDemoteBuild))
   trustDemoteBuild.delete();
exec("./trustManagerGUI.gui");
exec("./trustDemoteFull.gui");
exec("./trustDemoteBuild.gui");
if(!$TM::Binds) {
   $remapDivision[$remapCount] = "Trust Manager";
	$remapName[$remapCount] = "Toggle GUI";
	$remapCmd[$remapCount] = "tm_toggleGUI";
	$remapCount++;
   $TM::Binds = true;
}
function trustManagerGUI::onWake(%this) {
   tm_reloadList();
}
function tm_toggleGUI(%val) {
   if(!%val)
      return;
   switch (trustManagerGUI.isAwake()) {
      case 0: canvas.pushDialog(trustManagerGUI);
      case 1: canvas.popDialog(trustManagerGUI);
         tm_closeDemoteWindows();
   }
}
function tm_reloadList() {
   trustManager_list.clear();
   %fo = new FileObject();
   %fo.openForRead("config/client/prefs-trustList.txt");
   %id = 0;
   while(!%fo.isEOF()) {
      %buffer = %fo.readLine();
      %level = getField(%buffer, 1);
      trustManager_list.addRow(%id, getField(%buffer, 2) @ "\t" @ getField(%buffer, 0) @ "\t" @ (%level == 0 ? "None" : (%level == 2 ? "Full" : "Build")));
      %id++;
   }
   %fo.close();
   %fo.delete();
}
function tm_whoisUser() {
   if(strLen(%row = trustManager_list.getRowText(trustManager_list.getSelectedID())) < 1) {
      messageBoxOK("Trust Manager", "You must select a player to WhoIs!");
      return;
   }
   messageBoxOK("Trust Manager", "ID lookup will open shortly. If you have a slow browser, this might take a while.");
   gotoWebPage("forum.returntoblockland.com/list.php?cmd=view&id=" @ getField(%row, 1));
}
function tm_demoteUser(%bool, %level) {
   if(strLen(%row = trustManager_list.getRowText(trustManager_list.getSelectedID())) < 1) {
      messageBoxOK("Trust Manager", "You must select a player to demote!");
      return;
   }
   tm_closeDemoteWindows();
   if(%bool) {
      %fo = new FileObject();
      %fo.openForRead("config/client/prefs-trustList.txt");
      while(!%fo.isEOF()) {
         %line = %fo.readLine();
         %buff = "";
         if(getField(%line, 0) !$= getField(%row, 1))
            %buff = %line;
         else if(%level == 1)
            %buff = getField(%line, 0) TAB 1 TAB getField(%line, 2);
         if(strLen(%buff) > 0) {
            if(strLen(%write) < 1)
               %write = %buff;
            else
               %write = %write NL %buff;
      }
      }
      %fo.close();
      %fo.openForWrite("config/client/prefs-trustList.txt");
      %fo.writeLine(%write);
      %fo.close();
      %fo.delete();
      tm_reloadList();
   }
   else {
      if(getField(%row, 2) $= "Full") {
         trustDemoteFullText.setValue("Select a trust level to demote '"@getField(%row, 0)@"' to.");
         canvas.pushDialog(trustDemoteFull);
      }
      else {
         trustDemoteBuildText.setValue("Select a trust level to demote '"@getField(%row, 0)@"' to.");
         canvas.pushDialog(trustDemoteBuild);
      }
   }
}
function tm_closeDemoteWindows() {
   canvas.popDialog(trustDemoteFull);
   canvas.popDialog(trustDemoteBuild);
}